"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _moment = _interopRequireDefault(require("moment"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Panel = _interopRequireDefault(require("./Panel"));

var _placements = _interopRequireDefault(require("./placements"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function noop() {}

function generateOptions(length, disabledOptions, hideDisabledOptions) {
  var step = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;
  var arr = [];

  for (var value = 0; value < length; value += step) {
    if (!disabledOptions || disabledOptions.indexOf(value) < 0 || !hideDisabledOptions) {
      arr.push(value);
    }
  }

  return arr;
}

function refFn(field, component) {
  this[field] = component;
}

function getFormat(props) {
  var format = props.format,
      showHour = props.showHour,
      showMinute = props.showMinute,
      showSecond = props.showSecond,
      use12Hours = props.use12Hours;

  if (format) {
    return format;
  }

  if (use12Hours) {
    var fmtString = [showHour ? 'h' : '', showMinute ? 'mm' : '', showSecond ? 'ss' : ''].filter(function (item) {
      return !!item;
    }).join(':');
    return fmtString.concat(' a');
  }

  return [showHour ? 'HH' : '', showMinute ? 'mm' : '', showSecond ? 'ss' : ''].filter(function (item) {
    return !!item;
  }).join(':');
}

var Picker = /*#__PURE__*/function (_Component) {
  _inherits(Picker, _Component);

  var _super = _createSuper(Picker);

  function Picker(props) {
    var _this;

    _classCallCheck(this, Picker);

    _this = _super.call(this, props);

    _this.onPanelChange = function (value) {
      var str = value && value.format(getFormat(_this.props)) || '';

      _this.setValue(value);

      _this.setState({
        str: str,
        lastValidStr: str
      });
    };

    _this.onAmPmChange = function (ampm) {
      var onAmPmChange = _this.props.onAmPmChange;
      onAmPmChange(ampm);
    };

    _this.onClear = function (event) {
      event.stopPropagation();

      _this.setValue(null);

      _this.setState({
        open: false,
        str: '',
        lastValidStr: '',
        value: null
      });
    };

    _this.onVisibleChange = function (open) {
      _this.setOpen(open);
    };

    _this.onEsc = function () {
      _this.setOpen(false);

      _this.focus();
    };

    _this.onKeyDown = function (e) {
      if (e.keyCode === 40) {
        _this.setOpen(true);
      }

      if (e.keyCode === 27) {
        _this.onEsc();
      } // on tab


      if (e.keyCode === 9) {
        _this.setOpen(false);
      } // on enter


      if (e.keyCode === 13) {
        e.preventDefault();

        _this.setOpen(!_this.state.open);
      }
    };

    _this.isAM = function () {
      var defaultOpenValue = _this.props.defaultOpenValue;

      var _ref = _this.state || {},
          value = _ref.value;

      var realValue = value || defaultOpenValue;
      return realValue.hour() >= 0 && realValue.hour() < 12;
    };

    _this.disabledHours = function () {
      var _this$props = _this.props,
          use12Hours = _this$props.use12Hours,
          disabledHours = _this$props.disabledHours;
      var disabledOptions = disabledHours();

      if (use12Hours && Array.isArray(disabledOptions)) {
        if (_this.isAM()) {
          disabledOptions = disabledOptions.filter(function (h) {
            return h < 12;
          }).map(function (h) {
            return h === 0 ? 12 : h;
          });
        } else {
          disabledOptions = disabledOptions.map(function (h) {
            return h === 12 ? 12 : h - 12;
          });
        }
      }

      return disabledOptions;
    };

    _this.focus = function () {
      _this.picker.focus();
    };

    _this.onInputChange = function (event) {
      var str = event.target.value;

      _this.setState({
        str: str
      });

      var _this$props2 = _this.props,
          disabledMinutes = _this$props2.disabledMinutes,
          disabledSeconds = _this$props2.disabledSeconds,
          onChange = _this$props2.onChange;
      var _this$state = _this.state,
          hourOptions = _this$state.hourOptions,
          minuteOptions = _this$state.minuteOptions,
          secondOptions = _this$state.secondOptions;

      if (str) {
        var format = getFormat(_this.props);
        var originalValue = _this.state.value;

        var value = _this.getProtoValue().clone();

        var parsed = (0, _moment.default)(str, format, true);

        if (!parsed.isValid()) {
          _this.setState({
            invalid: true
          });

          return;
        }

        value.hour(parsed.hour()).minute(parsed.minute()).second(parsed.second()); // if time value not allowed, response warning.

        if (hourOptions.indexOf(value.hour()) < 0 || minuteOptions.indexOf(value.minute()) < 0 || secondOptions.indexOf(value.second()) < 0) {
          _this.setState({
            invalid: true
          });

          return;
        } // if time value is disabled, response warning.


        var disabledHourOptions = _this.disabledHours();

        var disabledMinuteOptions = disabledMinutes(value.hour());
        var disabledSecondOptions = disabledSeconds(value.hour(), value.minute());

        if (disabledHourOptions && disabledHourOptions.indexOf(value.hour()) >= 0 || disabledMinuteOptions && disabledMinuteOptions.indexOf(value.minute()) >= 0 || disabledSecondOptions && disabledSecondOptions.indexOf(value.second()) >= 0) {
          _this.setState({
            invalid: true
          });

          return;
        }

        if (originalValue) {
          if (originalValue.hour() !== value.hour() || originalValue.minute() !== value.minute() || originalValue.second() !== value.second()) {
            // keep other fields for rc-calendar
            var changedValue = originalValue.clone() || (0, _moment.default)();
            changedValue.hour(value.hour());
            changedValue.minute(value.minute());
            changedValue.second(value.second());

            _this.setValue(changedValue);

            _this.setState({
              lastValidStr: str
            });

            onChange(changedValue);
          }
        } else if (originalValue !== value) {
          _this.setValue(value);

          _this.setState({
            lastValidStr: str
          });

          onChange(value);
        }
      } else {
        _this.setState({
          lastValidStr: str
        });

        _this.setValue(null);

        onChange(null);
      }

      _this.setState({
        invalid: false
      });
    };

    _this.renderInputButton = function () {
      var _this$props3 = _this.props,
          prefixCls = _this$props3.prefixCls,
          inputIcon = _this$props3.inputIcon,
          disabled = _this$props3.disabled;

      if (!!_this.state.str || disabled) {
        return null;
      }

      if (_react.default.isValidElement(inputIcon)) {
        var _ref2 = inputIcon.props || {},
            _onClick = _ref2.onClick;

        return _react.default.cloneElement(inputIcon, {
          tabIndex: -1,
          onClick: function onClick() {
            var _this2;

            if (_onClick) _onClick.apply(void 0, arguments);

            (_this2 = _this).onClear.apply(_this2, arguments);
          }
        });
      }

      return /*#__PURE__*/_react.default.createElement("a", {
        role: "button",
        className: "".concat(prefixCls, "-input-button"),
        onClick: _this.focus,
        tabIndex: -1
      }, inputIcon || /*#__PURE__*/_react.default.createElement("i", {
        className: "".concat(prefixCls, "-input-icon")
      }));
    };

    _this.onFocus = function () {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        onFocus();
      }
    };

    _this.onBlur = function () {
      var onBlur = _this.props.onBlur;
      var _this$state2 = _this.state,
          invalid = _this$state2.invalid,
          lastValidStr = _this$state2.lastValidStr; // reset value if invalid

      if (invalid) {
        _this.setState({
          str: lastValidStr,
          invalid: false
        });
      }

      if (onBlur) {
        onBlur();
      }
    };

    _this.onSelection = function () {
      // console.log('onSelection');
      _this.focus();
    };

    _this.saveInputRef = refFn.bind(_assertThisInitialized(_this), 'picker');
    _this.savePanelRef = refFn.bind(_assertThisInitialized(_this), 'panelInstance');

    var defaultOpen = props.defaultOpen,
        defaultValue = props.defaultValue,
        _props$open = props.open,
        _open = _props$open === void 0 ? defaultOpen : _props$open,
        _props$value = props.value,
        _value = _props$value === void 0 ? defaultValue : _props$value,
        _disabledMinutes = props.disabledMinutes,
        _disabledSeconds = props.disabledSeconds,
        hideDisabledOptions = props.hideDisabledOptions,
        hourStep = props.hourStep,
        minuteStep = props.minuteStep,
        secondStep = props.secondStep;

    var _disabledHourOptions = _this.disabledHours();

    var _disabledMinuteOptions = _disabledMinutes(_value ? _value.hour() : null);

    var _disabledSecondOptions = _disabledSeconds(_value ? _value.hour() : null, _value ? _value.minute() : null);

    var _hourOptions = generateOptions(24, _disabledHourOptions, hideDisabledOptions, hourStep);

    var _minuteOptions = generateOptions(60, _disabledMinuteOptions, hideDisabledOptions, minuteStep);

    var _secondOptions = generateOptions(60, _disabledSecondOptions, hideDisabledOptions, secondStep);

    var _str = _value && _value.format(getFormat(props)) || '';

    _this.state = {
      open: _open,
      value: _value,
      str: _str,
      lastValidStr: _str,
      hourOptions: _hourOptions,
      minuteOptions: _minuteOptions,
      secondOptions: _secondOptions
    };
    return _this;
  }

  _createClass(Picker, [{
    key: "setValue",
    value: function setValue(value) {
      var onChange = this.props.onChange;
      this.setState({
        value: value
      });
      onChange(value);
    }
  }, {
    key: "getPanelElement",
    value: function getPanelElement() {
      var _this$props4 = this.props,
          prefixCls = _this$props4.prefixCls,
          placeholder = _this$props4.placeholder,
          disabledMinutes = _this$props4.disabledMinutes,
          disabledSeconds = _this$props4.disabledSeconds,
          hideDisabledOptions = _this$props4.hideDisabledOptions,
          inputReadOnly = _this$props4.inputReadOnly,
          showHour = _this$props4.showHour,
          showMinute = _this$props4.showMinute,
          showSecond = _this$props4.showSecond,
          defaultOpenValue = _this$props4.defaultOpenValue,
          clearText = _this$props4.clearText,
          addon = _this$props4.addon,
          use12Hours = _this$props4.use12Hours,
          focusOnOpen = _this$props4.focusOnOpen,
          onKeyDown = _this$props4.onKeyDown,
          hourStep = _this$props4.hourStep,
          minuteStep = _this$props4.minuteStep,
          secondStep = _this$props4.secondStep,
          clearIcon = _this$props4.clearIcon;
      var _this$state3 = this.state,
          value = _this$state3.value,
          hourOptions = _this$state3.hourOptions,
          minuteOptions = _this$state3.minuteOptions,
          secondOptions = _this$state3.secondOptions;
      return /*#__PURE__*/_react.default.createElement(_Panel.default, {
        clearText: clearText,
        prefixCls: "".concat(prefixCls, "-panel"),
        ref: this.savePanelRef,
        value: value,
        inputReadOnly: inputReadOnly,
        onChange: this.onPanelChange,
        onAmPmChange: this.onAmPmChange,
        defaultOpenValue: defaultOpenValue,
        showHour: showHour,
        showMinute: showMinute,
        showSecond: showSecond,
        onEsc: this.onEsc,
        format: getFormat(this.props),
        placeholder: placeholder,
        disabledMinutes: disabledMinutes,
        disabledSeconds: disabledSeconds,
        hideDisabledOptions: hideDisabledOptions,
        use12Hours: use12Hours,
        hourStep: hourStep,
        minuteStep: minuteStep,
        secondStep: secondStep,
        addon: addon,
        focusOnOpen: focusOnOpen,
        onKeyDown: onKeyDown,
        clearIcon: clearIcon,
        disabledHours: this.disabledHours,
        hourOptions: hourOptions,
        minuteOptions: minuteOptions,
        secondOptions: secondOptions,
        onSelection: this.onSelection
      });
    }
  }, {
    key: "getPopupClassName",
    value: function getPopupClassName() {
      var _this$props5 = this.props,
          showHour = _this$props5.showHour,
          showMinute = _this$props5.showMinute,
          showSecond = _this$props5.showSecond,
          use12Hours = _this$props5.use12Hours,
          prefixCls = _this$props5.prefixCls,
          popupClassName = _this$props5.popupClassName;
      var selectColumnCount = 0;

      if (showHour) {
        selectColumnCount += 1;
      }

      if (showMinute) {
        selectColumnCount += 1;
      }

      if (showSecond) {
        selectColumnCount += 1;
      }

      if (use12Hours) {
        selectColumnCount += 1;
      } // Keep it for old compatibility


      return (0, _classnames.default)(popupClassName, _defineProperty({}, "".concat(prefixCls, "-panel-narrow"), (!showHour || !showMinute || !showSecond) && !use12Hours), "".concat(prefixCls, "-panel-column-").concat(selectColumnCount));
    }
  }, {
    key: "setOpen",
    value: function setOpen(open) {
      var _this$props6 = this.props,
          onOpen = _this$props6.onOpen,
          onClose = _this$props6.onClose;
      var currentOpen = this.state.open;

      if (currentOpen !== open) {
        if (!('open' in this.props)) {
          this.setState({
            open: open
          });
        }

        if (open) {
          onOpen({
            open: open
          });
        } else {
          onClose({
            open: open
          });
        }
      }
    }
  }, {
    key: "getProtoValue",
    value: function getProtoValue() {
      var _this$props7 = this.props,
          value = _this$props7.value,
          defaultOpenValue = _this$props7.defaultOpenValue;
      return value || defaultOpenValue;
    }
  }, {
    key: "blur",
    value: function blur() {
      this.picker.blur();
    }
  }, {
    key: "click",
    value: function click() {
      this.picker.click();
    }
  }, {
    key: "renderClearButton",
    value: function renderClearButton() {
      var _this3 = this;

      var _this$props8 = this.props,
          prefixCls = _this$props8.prefixCls,
          allowEmpty = _this$props8.allowEmpty,
          clearIcon = _this$props8.clearIcon,
          clearText = _this$props8.clearText,
          disabled = _this$props8.disabled;

      if (!allowEmpty || !this.state.str || disabled) {
        return null;
      }

      if (_react.default.isValidElement(clearIcon)) {
        var _ref3 = clearIcon.props || {},
            _onClick2 = _ref3.onClick;

        return _react.default.cloneElement(clearIcon, {
          tabIndex: -1,
          onClick: function onClick() {
            if (_onClick2) _onClick2.apply(void 0, arguments);

            _this3.onClear.apply(_this3, arguments);
          }
        });
      }

      return /*#__PURE__*/_react.default.createElement("a", {
        role: "button",
        className: "".concat(prefixCls, "-clear"),
        title: clearText,
        onClick: this.onClear,
        tabIndex: -1
      }, clearIcon || /*#__PURE__*/_react.default.createElement("i", {
        className: "".concat(prefixCls, "-clear-icon")
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props9 = this.props,
          prefixCls = _this$props9.prefixCls,
          placeholder = _this$props9.placeholder,
          placement = _this$props9.placement,
          align = _this$props9.align,
          id = _this$props9.id,
          disabled = _this$props9.disabled,
          transitionName = _this$props9.transitionName,
          style = _this$props9.style,
          className = _this$props9.className,
          inputClassName = _this$props9.inputClassName,
          getPopupContainer = _this$props9.getPopupContainer,
          name = _this$props9.name,
          autoComplete = _this$props9.autoComplete,
          autoFocus = _this$props9.autoFocus,
          inputReadOnly = _this$props9.inputReadOnly,
          popupStyle = _this$props9.popupStyle;
      var _this$state4 = this.state,
          open = _this$state4.open,
          str = _this$state4.str;
      var popupClassName = this.getPopupClassName();
      var invalid = this.state.invalid;
      var invalidClass = invalid ? "".concat(prefixCls, "-input-invalid") : '';
      return /*#__PURE__*/_react.default.createElement(_rcTrigger.default, {
        prefixCls: "".concat(prefixCls, "-panel"),
        popupClassName: popupClassName,
        popupStyle: popupStyle,
        popup: this.getPanelElement(),
        popupAlign: align,
        builtinPlacements: _placements.default,
        popupPlacement: placement,
        action: disabled ? [] : ['focus'],
        destroyPopupOnHide: true,
        getPopupContainer: getPopupContainer,
        popupTransitionName: transitionName,
        popupVisible: open,
        onPopupVisibleChange: this.onVisibleChange
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: (0, _classnames.default)(prefixCls, className),
        style: style
      }, /*#__PURE__*/_react.default.createElement("input", {
        className: (0, _classnames.default)("".concat(prefixCls, "-input"), invalidClass, inputClassName),
        ref: this.saveInputRef,
        placeholder: placeholder,
        onChange: this.onInputChange,
        readOnly: !!inputReadOnly,
        type: "text",
        name: name,
        onKeyDown: this.onKeyDown,
        disabled: disabled,
        value: str,
        autoComplete: autoComplete,
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        autoFocus: autoFocus // eslint-disable-line jsx-a11y/no-autofocus
        ,
        id: id
      }), this.renderInputButton(), this.renderClearButton()));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var newState = {};

      if ('value' in props) {
        var value = props.value;
        var oldVal = state.value;

        if (value !== oldVal) {
          newState.value = value;
          newState.str = value && value.format(getFormat(props)) || '';
        }
      }

      if (props.open !== undefined) {
        newState.open = props.open;
      }

      return Object.keys(newState).length > 0 ? _objectSpread(_objectSpread({}, state), newState) : null;
    }
  }]);

  return Picker;
}(_react.Component);

Picker.defaultProps = {
  clearText: 'clear',
  prefixCls: 'rc-time-picker',
  defaultOpen: false,
  inputReadOnly: false,
  style: {},
  className: '',
  inputClassName: '',
  popupClassName: '',
  popupStyle: {},
  align: {},
  defaultOpenValue: (0, _moment.default)(),
  allowEmpty: true,
  showHour: true,
  showMinute: true,
  showSecond: true,
  disabledHours: noop,
  disabledMinutes: noop,
  disabledSeconds: noop,
  hideDisabledOptions: false,
  placement: 'bottomLeft',
  onChange: noop,
  onAmPmChange: noop,
  onOpen: noop,
  onClose: noop,
  onFocus: noop,
  onBlur: noop,
  addon: noop,
  use12Hours: false,
  focusOnOpen: true,
  onKeyDown: noop,
  autoComplete: 'off'
};
var _default = Picker;
exports.default = _default;